/* $Id: window.c,v 1.1.1.1 1995/07/22 00:57:18 sverrehu Exp $ */
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>

#ifdef AW3D
#include <X11/Xaw3d/Form.h>
#include <X11/Xaw3d/Command.h>
#include <X11/Xaw3d/AsciiText.h>
#include <X11/Xaw3d/Text.h>
#include <X11/Xaw3d/TextSrc.h>
#include <X11/Xaw3d/TextSink.h>
#include <X11/Xaw3d/AsciiSrc.h>
#include <X11/Xaw3d/AsciiSink.h>
#else
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/AsciiText.h>
#include <X11/Xaw/Text.h>
#include <X11/Xaw/TextSrc.h>
#include <X11/Xaw/TextSink.h>
#include <X11/Xaw/AsciiSrc.h>
#include <X11/Xaw/AsciiSink.h>
#endif

#include "misc.h"

void getFontWH(Widget widget, int *w, int *h)
{
    XFontStruct *fs;

    XtVaGetValues(widget, XtNfont, &fs, NULL);
    if (!fs)
	Fatal("Unable to get font from widget");
    *w = (int) fs->max_bounds.width;
    *h = (int) fs->max_bounds.ascent + fs->max_bounds.descent;
}

void closeButton(Widget w, XtPointer client_data, XtPointer call_data)
{
    exit(1);
}

void openWindow(int argc, char *argv[], char *text)
{
    int fw, fh;
    XtAppContext app_context;
    Widget topLevel, form, msg, butt;

    topLevel = XtVaAppInitialize(
        &app_context,
        "Motd",
        NULL, 0,
        &argc, argv,
        NULL,
        NULL
    );
    form = XtVaCreateManagedWidget(
        "form",
        formWidgetClass,
        topLevel,
        NULL
    );
    msg = XtVaCreateManagedWidget(
        "message",
        asciiTextWidgetClass,
        form,
	XtNeditType, XawtextRead,
	XtNdisplayCaret, False,
	XtNscrollHorizontal, XawtextScrollWhenNeeded,
	XtNscrollVertical, XawtextScrollWhenNeeded,
	XtNstring, text,
        NULL
    );
    getFontWH(msg, &fw, &fh);
    XtVaSetValues(
        msg,
        XtNwidth, 80 * fw,
	XtNheight, 15 * fh,
        NULL
    );
    butt = XtVaCreateManagedWidget(
        "Yep, I've read it!",
        commandWidgetClass,
        form,
	XtNfromVert, msg,
        NULL
    );
    XtAddCallback(butt, XtNcallback, closeButton, 0);
    XtRealizeWidget(topLevel);
    XtAppMainLoop(app_context);
}
